<template>
  <!-- We don't use "rui-form" here as it's not suitable for this form -->
  <form action="#" class="gpa-map-form" @submit.prevent="save">
    <div class="-grid-1-2 -gap">
      <div>
        <rui-errors :errors="errors" model="map" />

        <fieldset>
          <legend>{{ $t('js.maps.form.groups.general') }}</legend>
          <rui-field input-id="map_name" :label="$t('activerecord.attributes.map.name')">
            <input id="map_name"
                   v-model="inputs.name"
                   type="text"
                   name="name"
                   :placeholder="$t('js.maps.form.name_placeholder')"
                   required>
          </rui-field>

          <rui-field :help="$t('js.maps.form.publicly_available_help')">
            <label for="map_publicly_available">
              <input id="map_publicly_available"
                     v-model="inputs.publicly_available"
                     type="checkbox"
                     name="publicly_available">
              {{ $t('activerecord.attributes.map.publicly_available') }}</label>
          </rui-field>
        </fieldset>

        <fieldset class="-mtd">
          <legend>{{ $t('js.maps.form.groups.center_definition') }}</legend>

          <rui-alert variant="info">{{ $t('js.maps.form.select_center_note') }}</rui-alert>
        </fieldset>

        <div class="-text--right -mtd">
          <rui-submit-button :loading="loading" :caption="$t('js.maps.form.save_this_map')" :disabled="!centerChanged" />
        </div>
      </div>
      <div>
        <div id="map" class="gpa-map-form__map" />
      </div>
    </div>
  </form>
</template>

<script>
import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiErrors from '@experiments-labs/rise_ui/src/components/DataDisplay/Error/Errors.vue'
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiSubmitButton from '@experiments-labs/rise_ui/src/components/Inputs/SubmitButton/SubmitButton.vue'

import MapEditionMixin from '../mixins/MapEdition'

export default {
  name: 'GpaNewOsmMapForm',
  components: { RuiSubmitButton, RuiAlert, RuiField, RuiErrors },
  mixins: [MapEditionMixin],
  data () {
    return {
      inputs: {
        name: '',
        center: null,
        publicly_available: false,
      },

      loading: false,
      errors: null,
    }
  },
  methods: {
    save () {
      const payload = { ...this.inputs }
      this.errors = null
      this.loading = true
      this.$store.dispatch('createMap', payload)
        .then((map) => {
          this.$router.push({ name: 'map', params: { mapId: map.id } })
        })
        .catch(error => { this.errors = error })
        .then(() => { this.loading = false })
    },
  },
  created () {
    this.$nextTick(() => {
      this.loadOSMMap()
      this.enterCenterSelectionMode()
    })
  },

}
</script>

<style lang="scss" src="./MapForm.scss" />
